import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;  // wird bentigt um java.util.List benutzen zu knnen fr die Methode getObjects()

/**
 * Write a description of class Mario here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Mario  extends Objects
{
    // Gibt die Geschwindigkeit an
    private int speed                  =    4;
    // derzeitige und minimale Sprungverzgerung, verhindert zu schnelles hintereinander springen
    private int jumpDelay              =    0;
    private int minJumpDelay           =    25;
    // Gibt die Anzahl der gesamelten Sterne an
    private  int starCounter            =    0;
    // Zhler, der die Anzahl der gesammelten Sterne ausgibt
    private Counter starCount;
    // Das standart Bild von Mario
    static GreenfootImage marioPic = new GreenfootImage ("mario_right.png");
    // Das Mario Bild nach rechts
    private GreenfootImage marioRight = new GreenfootImage ("mario_right.png");
    // Das Mario Bild nach links
    private GreenfootImage marioLeft = new GreenfootImage ("mario_left.png");
    
    // Konstruktor von Mario
    public Mario(Counter star)
    {
        starCount = star;
        setImage(marioPic);
    }
    
    public void act() 
    {
        if(active)
        {
            checkKeys();
            checkFall(marioPic.getHeight());
            moveWorld();
            checkX();
            jumpDelay++;
            onKoopa_down();
            killGoomba();
            killKoopa();
            pickUpStar();
            checkDead();
        }
    }
    
    /**
     * Ttet einen Goomba, wenn er sich unter Mario befindet, erstellt einen toten Goomba und lsst Mario springen
     */
    public void killGoomba()
    {
        if(objectUnder( marioPic.getHeight(), Goomba.class))
        {
            Actor actor = getOneObjectAtOffset(0, marioPic.getHeight()/ 2, Goomba.class);
            if(actor != null) 
            {
            getWorld().removeObject(actor);
            getWorld().addObject(new DeadGoomba(), getX(), getY() + marioPic.getHeight() *3/4);
            jump(marioPic.getHeight());
            }
        }
    }
    
    /**
     * Ttet einen Koopa, wenn er sich unter Mario befindet, erstellt einen toten Koopa und lsst Mario springen
     */
    public void killKoopa()
    {
        if(objectUnder( marioPic.getHeight(), Koopa.class))
        {
            Actor actor = getOneObjectAtOffset(0, marioPic.getHeight()/ 2, Koopa.class);
            if(actor != null) 
            {
            getWorld().removeObject(actor);
            getWorld().addObject(new Koopa_down(), getX(), getY() + marioPic.getHeight()*1/3);
            jump(marioPic.getHeight());
            }
        }
    }
    
    /**
     * Lst Mario springen, wenn ein toter Koopa unter im ist
     */
    public void onKoopa_down()
    {
        if(objectUnder( marioPic.getHeight(), Koopa_down.class))
        {
            jump(marioPic.getHeight());
        }
    }
    
    /**
     * Sammelt einen Stern auf und erhht den Sternezhler um eins
     */
    public void pickUpStar()
    {
        if(objectAt(Star.class))
        {
            Actor actor = getOneIntersectingObject(Star.class);
            if(actor != null)
            {
                getWorld().removeObject(actor);
                starCounter++;
                starCount.setText("Sterne: " + starCounter + "/10");
                Greenfoot.playSound("coins.wav");
            }        
        }
    }
    
    /**
     * berprft ob Mario einen Gegner berhrt hat oder unter der Welt ist, wenn ja wird das Spiel angehalten, spielt
     * einen Sound ab und das Menu wird aufgerufen
     */
    public void checkDead()
    {
        if(enemyContact() || checkY())
        {
            active = false;
            Greenfoot.playSound("lose.wav");
            getWorld().addObject( new Game_over(), 275, 110);
            getWorld().addObject( new Restart_button(), 175, 250);
            getWorld().addObject( new Menu_button(), 410, 250); 
            getWorld().removeObject(MarioWorld.stopbutton);
        }        
    }
    
    /**
     * berprft, ob Mario unterhalb der Welt ist
     */
    public boolean checkY()
    {
        if(getY() >= getWorld().getHeight() + marioPic.getHeight()/2)
        {
            return true;
        }
        return false;
    }
    
    /**
     * berprft, ob Mario mit einem Gegner Kontakt hat
     */
    public boolean enemyContact()
    {
        if((objectToRight(marioPic.getWidth() -6, Enemy.class)) || (objectToLeft(marioPic.getWidth() -6, Enemy.class)) || (objectAbove( marioPic.getHeight(), Enemy.class)) )
        {
            return true;
        }
        return false;
    }
   
    /**
     * Lsst Mario nicht links aus der Welt laufen
     */
    public void checkX()
    {
        if(getX() < marioPic.getWidth() / 2)
        {
            setLocation( marioPic.getWidth() / 2, getY());
        }
    }
    
    /**
     * Bewegt alle Objekte nach links, wenn Mario ber die rechte Hlfte der Welt luft
     */
    public void moveWorld()
    {
        if(getX() > getWorld().getWidth() / 2)
        {
            List list = getWorld().getObjects(Objects.class);
            for (int i = 0; i < list.size() ; i++)
            {
                Actor obj = (Actor) list.get(i);
                obj.setLocation(obj.getX() - speed, obj.getY());
            }
        }
    }
    
    /**
     * berprft welche Taste gedrckt wird:
     * linke Pfeiltaste -> nach links laufen, wenn keine Hindernisse im weg stehen
     * rechte Pfeiltaste -> nach rechts laufen, wenn keine Hindernisse im weg stehen
     * Pfeiltaste nach oben -> lsst Mario springen, wenn er auf dem Boden steht und die mininmale Sprungverzgerung
     * erreicht ist
     */
    private void checkKeys()
    {
        if (Greenfoot.isKeyDown("left") && !objectToLeft(marioPic.getWidth() ,Ground.class) && !objectToLeft(marioPic.getWidth() ,Tunnel.class))
        {
            setLocation(getX() - speed, getY());
            setImage(marioLeft);
        }
        if (Greenfoot.isKeyDown("right") && !objectToRight(marioPic.getWidth() ,Ground.class) && !objectToRight(marioPic.getWidth() ,Tunnel.class))
        {
            setLocation(getX() + speed, getY());
            setImage(marioRight);
        }
        if (Greenfoot.isKeyDown("up") && objectUnder(marioPic.getHeight(), Ground.class) && jumpDelay > minJumpDelay)
        {
            jump(marioPic.getHeight());
            jumpDelay = 0;
        }
    }
}
