import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

public class Objects  extends Actor
{
    // Die vertikale Geschwindigkeit, die das Objekt gerade fllt
    private int vSpeed = 0;
    // Die maximale vertikale Geschwindigkeit, darf nicht berschritten werden
    private int maxVSpeed = 15;
    // Die vertikale Beschleunigung, die das Objekt zunimmt, wenn es nicht auf dem Boden etc steht
    private int acceleration = 1;
    // Die Sprungkraft, wenn das Objekt(nur Mario) springt
    private int jumpStrength = 12;
    // Gibt an ob das Spiel luft oder stopt
    static boolean active = true;
    
    /**
     * Lsst das Objekt fallen, wenn es nicht auf dem Boden steht.
     * Die maxVSpeed darf nicht berschritten werden und wenn ber dem Objekt Boden ist, fllt es.
     */
    public void fall(int height)
    {
        if(vSpeed <= maxVSpeed)
        {
            vSpeed = vSpeed + acceleration;
        }
        if(objectAbove(height, Ground.class))
        {
            vSpeed = 2;
        }
        setLocation ( getX(), getY() + vSpeed);
    }
    
    /**
     * berprft ob Boden, Tunnel oder ein Gegner unter dem Objekt ist, wenn ja, bleibt das Objekt stehen,
     * sonst wird die Methode fall() aufgefhrt.
     */
    public void checkFall(int height)
    {
        if(objectUnder( height ,Ground.class) || objectUnder( height,Tunnel.class) || objectUnder( height ,Enemy.class))
        {
            vSpeed = 0;
        }
        else
        {
            fall(height);
        }
    }
    
     /**
     * Lst das Object springen, indem der vSpeed auf den negativen Wert von Sprungkraft gestellt wird.
     * Aktiviert einen Sound.
     */
    public void jump(int height)
    {
        vSpeed = -jumpStrength;
        fall(height);
        Greenfoot.playSound("jump.wav");
    }
    
     /**
     * berprft, ob eine bestimmte Klasse sich auf der Position des Objektes befindet.
     */
    public boolean objectAt(Class clss)
    {
        Actor actor = getOneObjectAtOffset(0, 0, clss);
        return actor != null;
    }
    
    /**
     * berprft, ob eine bestimmte Klasse sich unter dem Object befindet.
     */
    public boolean objectUnder(int height, Class clss)
    {
        Actor under = getOneObjectAtOffset ( 0, (int) height / 2 , clss);
        return under != null;
    }
    
    /**
     * berprft, ob eine bestimmte Klasse sich ber dem Object befindet.
     */
    public boolean objectAbove(int height, Class clss)
    {
        Actor above = getOneObjectAtOffset ( 0, (int) -height / 2, clss);
        return above != null;
    }
    
    /**
     * berprft, ob eine bestimmte Klasse sich rechts vom Object befindet.
     */
    public boolean objectToRight(int width, Class clss)
    {
        Actor right = getOneObjectAtOffset ( (int) width / 2, 0, clss);
        return right != null;
    }
    
    /**
     * berprft, ob eine bestimmte Klasse sich links vom Object befindet.
     */
    public boolean objectToLeft(int width, Class clss)
    {
        Actor left = getOneObjectAtOffset ( (int) -width / 2, 0, clss);
        return left != null;
    }
}
